SystemOrganization addCategory: #'Spec-Builder'!
SystemOrganization addCategory: #'Spec-Builder-Tools'!

!Class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 2/28/2012 20:27'!
addSourceCode: source into: selector
	| method newSource |
	method := self methodDict at: selector asSymbol ifAbsent: [ ^ self ].
	newSource := String streamContents: [:s |
		s << method sourceCode << '.' ; cr ; tab ;<< source ].
	self compileWithoutReturn: newSource classified: method category! !

!Class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 2/27/2012 07:45'!
subclass: newName category: newCategory

	| result |
	result := self subclass: newName
					instanceVariableNames: ''
					classVariableNames: ''
					poolDictionaries: ''
					category: newCategory.
	^ result 
		ifNil: [ Smalltalk at: name ifAbsent: [ nil ]]
		ifNotNil: [ result ]! !

!ComposableModel class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 2/28/2012 14:15'!
possibleEvents

	^ #()! !

ComposableModel subclass: #InstVarAdder
	instanceVariableNames: 'description nameField nameLabel toolbar typeField typeLabel typeChoice selectedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder-Tools'!

!InstVarAdder class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/28/2012 22:25'!
internSpec
	| height width |
	height := 25.
	width := (StandardFonts defaultFont widthOfString: 'Name:') + 10.
	^ { #Panel.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #nameLabel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 ( 0@0 corner: 0.5@1 ).	(0@0 corner: 0@(2*height) negated). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #nameField. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	( 0@0 corner: 1@1 ).	(width@0 negated corner: 0@(2*height) negated). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #typeLabel. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@1 corner: 0.5@1).	(0@(2*height negated) corner: 0@(height negated)). }}.										
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #typeChoice. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@1 corner: 1@1).	(width@(2*height negated) corner: 0@(height negated)). }}.
																		
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 	{#model. #toolbar. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@1 corner: 1@1).	(0@(height negated) corner: 0@0). }}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill}.! !

!InstVarAdder class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/28/2012 21:54'!
title

	^ 'Add an inst var...'! !

!InstVarAdder methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/28/2012 22:28'!
accept
	| name cl |
	nameField accept.
	(name := nameField getText) isEmptyOrNil ifFalse: [
			cl := selectedClass contents.
			cl ifNil: [ cl := ComposableModel ].
			description contents addInstVarNamed: name kindOf: cl.
			description contentsChanged ]! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 22:07'!
description
	^ description contents! !

!InstVarAdder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 21:34'!
description: aDescription

	description contents: aDescription! !

!InstVarAdder methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/28/2012 21:55'!
initialExtent

	^ 260@115! !

!InstVarAdder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/28/2012 22:41'!
initialize
	"Initialization code for InstVarAdder"
	super initialize.

	description := nil asValueHolder.
	nameField := self instantiate: TextInputFieldModel.
	nameLabel := self instantiate: LabelModel.
	toolbar := self instantiate: OkCancelToolbar.
	typeChoice := self instantiate: DropListModel.
	typeLabel := self instantiate: LabelModel.
	
	nameLabel text: 'Name:'.
	nameField 
		autoAccept: true;
		entryCompletion: nil.
	typeLabel text: 'Class:'.
	selectedClass := nil asValueHolder .

	typeChoice items: ((ComposableModel subclasses sort: [:a :b | a name < b name ]) collect: [: e | DropListItem named: e name do: [ selectedClass contents: e ]]) .
	
	toolbar okAction: [ self accept ]! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
nameField
	^ nameField! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
nameLabel
	^ nameLabel! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
selectedClass
	^ selectedClass! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
toolbar
	^ toolbar! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
typeChoice
	^ typeChoice! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
typeField
	^ typeField! !

!InstVarAdder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:59'!
typeLabel
	^ typeLabel! !

!InstVarAdder methodsFor: 'protocol-events' stamp: 'BenjaminVanRyseghem 2/28/2012 22:04'!
whenDescriptionChanges: aBlock

	description whenChangedDo: aBlock! !

ComposableModel subclass: #InstVarSetter
	instanceVariableNames: 'list picklist text okCancelToolbar bindings descriptionHolder addButton removeButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder-Tools'!

!InstVarSetter class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/28/2012 20:35'!
internSpec
	| delta |
	delta := 25.
	^{ #PanelWithSplitters.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #list. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@0 corner: 0.33@1).	(0@0 corner: 0@((2*delta) negated)). }}.
																		
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #addButton. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@1 corner: 0.16@1).	(0@((2*delta) negated) corner: 0@(delta negated)). }}.

			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #removeButton. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0.16@1 corner: 0.33@1).	(0@((2*delta) negated) corner: 0@(delta negated)). }}.

			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #picklist. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0.33@0 corner: 0.66@1).	(0@0 corner: 0@(delta negated)). }}.															
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #text. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0.66@0 corner: 1@1).		(0@0 corner: 0@(delta negated)). }}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #okCancelToolbar. #internSpec.}.
											#fullFrame:. 	{#LayoutFrame.
																#fractions:offsets:.	 (0@1 corner: 1@1).		(0@(delta negated) corner: 0@0). }}.
			#addPaneSplitters.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!InstVarSetter class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/28/2012 01:40'!
title

	^'Inst var setter'! !

!InstVarSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 20:29'!
accept
	| instVars desc |
	desc := descriptionHolder contents.
	desc ifNil: [ ^ self ].
	
	instVars := bindings select: [:assoc | assoc notNil and: [ assoc values anySatisfy: [:v | v value ]]].
	instVars associations do: [:assoc || instVar source events |
		instVar := assoc key.
		source := String streamContents: [:s | s << 'register' << instVar name capitalized << 'Events'].
		desc addCodeToInitialize: 'self ', source order: 1.
		desc addMethodWithSource: source category: 'initialization'.
		events := assoc value select: [:a | a value ].
		events associations do: [:a || src |
			src := String streamContents: [:s | s << instVar name << ' ' << a key asString << ': ['  << a value key  << '].'].
			desc addCodeTo: source source: src order: 1 ]].! !

!InstVarSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:32'!
addButton

	^ addButton! !

!InstVarSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/28/2012 22:05'!
addInstVar
	| adder |
	
	adder := InstVarAdder new.
	adder 
		description: descriptionHolder contents;
		openWithSpec.
		
	adder whenDescriptionChanges: [ self description: adder description ]! !

!InstVarSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 14:20'!
description

	^ descriptionHolder contents! !

!InstVarSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 14:11'!
description: aDescription

	descriptionHolder contents: aDescription! !

!InstVarSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/28/2012 14:20'!
hasBindingOf: aString 
	
	^ self description
		ifNil: [ false ]
		ifNotNil: [:desc | (desc addInstVarDescriptions collect: #name) includes: aString ]! !

!InstVarSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/28/2012 14:21'!
hasBindingThatBeginsWith: aString
	
	^ self description
		ifNil: [ false ]
		ifNotNil: [:desc | (desc addInstVarDescriptions collect: #name) anySatisfy: [:name | name beginsWith: aString ]]! !

!InstVarSetter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/28/2012 03:38'!
initialExtent

	^ (700 min: (World extent x)) @ (300 min: (World extent y))! !

!InstVarSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/28/2012 20:33'!
initialize
	"Initialization code for InstVarSetter"

	super initialize.

	list := self instantiate: ListComposableModel.
	picklist := self instantiate: PickListModel.
	text := self instantiate: TextModel.
	descriptionHolder := nil asValueHolder.
	okCancelToolbar := self instantiate: OkCancelToolbar.
	addButton := self instantiate: ButtonModel.
	removeButton := self instantiate: ButtonModel.
	bindings := Dictionary new.
	
	list wrappingBlock: [:e | e name ].
	picklist labelClickable: false.
	text aboutToStyle: true.
	text enabled: false.
	okCancelToolbar okAction: [ self accept ].

	addButton
		label: '+';
		state: false;
		action: [ self addInstVar ].
		
	removeButton
		label: '-';
		state: false;
		action: [ self removeInstVar ].
	
	self registerListEvents.
	self registerPickListEvents.
	self registerDescriptionEvents.
	self registerTextEvents! !

!InstVarSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 14:19'!
inspectedClass

	^ descriptionHolder contents addClassDescription! !

!InstVarSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 02:02'!
list
	^ list! !

!InstVarSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 03:22'!
okCancelToolbar
	^ okCancelToolbar! !

!InstVarSetter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 05:43'!
openWithSpec

	super openWithSpec.
	text morph ifNotNil: [:m | m styler workspace: self ]! !

!InstVarSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 02:02'!
picklist
	^ picklist! !

!InstVarSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/28/2012 14:13'!
registerDescriptionEvents

	descriptionHolder whenChangedDo: [:desc|| items |
		items := desc addInstVarDescriptions select: [:e | e type inheritsFrom: ComposableModel ].
		list items: (items sort: [:a :b | a name < b name ])]! !

!InstVarSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/28/2012 14:14'!
registerListEvents

	list whenSelectedItemChanges: [:instVarDesc || item |
		instVarDesc
			ifNil: [ picklist items: {} ]
			ifNotNil: [
				picklist items: (instVarDesc type possibleEvents) ].
		picklist resetSelection.
		text text: '' ]! !

!InstVarSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/28/2012 06:40'!
registerPickListEvents
	
	picklist whenPickedItemsChanges: [:item :old|
		item ifNotNil: [
			((bindings at: list selectedItem ifAbsentPut: [ Dictionary new ]) at: item ifAbsentPut: [ ''->false ]) value: old ]].
	
	picklist whenSelectedItemChanges: [:item || txt |
		item 
			ifNil: [ 
				text text: ''.
				text enabled: false ]
			ifNotNil: [
				txt := ((bindings at: list selectedItem ifAbsentPut: [ Dictionary new ]) at: item ifAbsentPut: [ ''->false ]) key.
				text text: txt.
				text enabled: true ]]! !

!InstVarSetter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/28/2012 06:38'!
registerTextEvents

	text action: [:txt || item |
		item := picklist selectedItem.
		((bindings at: list selectedItem ifAbsentPut: [ Dictionary new ]) at: item ifAbsentPut: [ ''->false ]) key: txt .
		(picklist checkboxFor: item) state: true.]! !

!InstVarSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:32'!
removeButton

	^ removeButton! !

!InstVarSetter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 02:02'!
text
	^ text! !

ComposableModel subclass: #SpecTest
	instanceVariableNames: 'toto titi'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!SpecTest class methodsFor: 'generating' stamp: 'BenjaminVanRyseghem 2/28/2012 19:39'!
generatingSpec
	
	^ #(#model #subclass:category: #SpecTest 'Spec-Builder' #addInstVarNamed: 'toto' #addInstVarNamed: 'titi' #compileWithoutReturn:classified: 'initialize
	
	super initialize' 'initialize' #compileWithoutReturn:classified: 'test1 ^1' 'test' #compileWithoutReturn:classified: 'test2 ^2' 'test' #addSourceCode:into: 'toto := self instantiate: TextModel' #initialize #addSourceCode:into: 'self test1' #initialize #addSourceCode:into: 'self test2.' #initialize )! !

!SpecTest methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 2/28/2012 19:39'!
initialize
	
	super initialize.
	toto := self instantiate: TextModel.
	self test1.
	self test2.! !

!SpecTest methodsFor: 'test' stamp: 'BenjaminVanRyseghem 2/28/2012 19:39'!
test1 ^1! !

!SpecTest methodsFor: 'test' stamp: 'BenjaminVanRyseghem 2/28/2012 19:39'!
test2 ^2! !

!PickListModel class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 2/28/2012 14:17'!
possibleEvents

	^ #(whenListChanges whenSelectionChanges whenSelectedItemChanges whenSelectedIndexChanges whenPickeItemsChanges)! !

!TextModel class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 2/28/2012 14:25'!
possibleEvents

	^ #(whenTextChanges:)! !

!ListComposableModel class methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 2/28/2012 14:17'!
possibleEvents

	^ #(whenListChanges whenSelectionChanges whenSelectedItemChanges whenSelectedIndexChanges)! !

Object subclass: #AbstractDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!AbstractDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:35'!
generate

	^ self generateSpec asOrderedCollection addFirst: #model; asArray! !

!AbstractDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:44'!
generateSpec

	^ self subclassResponsibility! !

AbstractDescription subclass: #AddClassDescription
	instanceVariableNames: 'category name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!AddClassDescription class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/27/2012 07:38'!
category: ctgr name: newClassName

	^ self new
		category: ctgr;
		newClassName: newClassName;
		yourself! !

!AddClassDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:12'!
category
	^ category! !

!AddClassDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:12'!
category: anObject
	category := anObject! !

!AddClassDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:45'!
generateSpec

	^ {	#subclass:category:.
		self newClassName asSymbol.
		self category}
		! !

!AddClassDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:17'!
name: anObject
	
	name := anObject! !

!AddClassDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:13'!
newClassName

	^ name! !

!AddClassDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:13'!
newClassName: anObject

	name := anObject! !

AbstractDescription subclass: #AddInstVarDescription
	instanceVariableNames: 'name type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!AddInstVarDescription class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/28/2012 13:56'!
name: newName

	^ self 
		name: newName
		type: Object! !

!AddInstVarDescription class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/28/2012 13:56'!
name: newName type: type

	^ self new
		name: newName;
		type: type;
		yourself! !

!AddInstVarDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:26'!
generateSpec

	^ { #addInstVarNamed:.	self name }! !

!AddInstVarDescription methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/27/2012 06:48'!
initialize
	"Initialization code for AddInstVarDescription"

	super initialize.

	name := ''.! !

!AddInstVarDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:41'!
name
	^ name! !

!AddInstVarDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:40'!
name: anObject
	name := anObject! !

!AddInstVarDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 13:55'!
type
	^ type! !

!AddInstVarDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 13:55'!
type: anObject
	type := anObject! !

AbstractDescription subclass: #AddIntoMethodDescription
	instanceVariableNames: 'code order selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!AddIntoMethodDescription class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
code: code order: order selector: selector

	^ self new
		code: code;
		order: order;
		selector: selector;
		yourself! !

!AddIntoMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
code
	^ code! !

!AddIntoMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
code: anObject
	code := anObject! !

!AddIntoMethodDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 2/27/2012 08:00'!
generateSpec
	
	^ { #addSourceCode:into:. self code. self selector }! !

!AddIntoMethodDescription methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/27/2012 06:48'!
initialize
	"Initialization code for AddIntoInitializeDescription"

	super initialize.

	block := ''.! !

!AddIntoMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
order
	^ order! !

!AddIntoMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
order: anObject
	order := anObject! !

!AddIntoMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
selector
	^ selector! !

!AddIntoMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:09'!
selector: anObject
	selector := anObject! !

AbstractDescription subclass: #AddMethodDescription
	instanceVariableNames: 'category selector source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!AddMethodDescription class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 2/27/2012 07:00'!
category: category source: source

	^ self new
		category: category;
		source: source;
		yourself! !

!AddMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:47'!
category
	^ category! !

!AddMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:47'!
category: anObject
	category := anObject! !

!AddMethodDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:50'!
generateSpec
	
	^ { #compileWithoutReturn:classified:.	self source.	self category.}! !

!AddMethodDescription methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/27/2012 07:07'!
initialize
	"Initialization code for AddMethodDescription"

	super initialize.

	category := ''.
	selector := ''.
	source := ''.! !

!AddMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:41'!
selector
	^ selector! !

!AddMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:41'!
selector: anObject
	selector := anObject! !

!AddMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:41'!
source
	^ source! !

!AddMethodDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:41'!
source: anObject
	source := anObject! !

AbstractDescription subclass: #ComposableModelDescription
	instanceVariableNames: 'addClassDescription addInstVarDescriptions addMethodDescriptions addIntoMethodDescriptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/28/2012 14:07'!
addClassDescription

	^ addClassDescription! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 2/28/2012 20:18'!
addClassNamed: name categorized: category

	addClassDescription := AddClassDescription
								category: category
								name: name.
								
	self addMethodWithSource: 'initialize
	
	super initialize' category: 'initialize'.! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 2/27/2012 08:01'!
addCodeTo: selector source: source order: order

	addIntoMethodDescriptions add: (AddIntoMethodDescription 
													code: source
													order: order
													selector: selector).! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 2/27/2012 07:56'!
addCodeToInitialize: source order: order

	addIntoMethodDescriptions add: (AddIntoMethodDescription 
													code: source
													order: order
													selector: #initialize).! !

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:58'!
addInstVarDescriptions
	^ addInstVarDescriptions! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 2/27/2012 06:59'!
addInstVarNamed: aString

	addInstVarDescriptions add: (AddInstVarDescription name: aString)! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 2/28/2012 14:01'!
addInstVarNamed: aString kindOf: aClass

	addInstVarDescriptions add: (AddInstVarDescription name: aString type: aClass)! !

!ComposableModelDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 14:01'!
addInstVarNamed: aString kindOf: aClass order: order

	self addInstVarNamed: aString kindOf: aClass.
	self addCodeToInitialize: aString, ' := ', aClass name, ' new' order: order! !

!ComposableModelDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/27/2012 08:09'!
addInstVarNamed: aString kindOfComposablaeModel: aComposableModelClass

	self addInstVarNamed: aString kindOfComposablaeModel: aComposableModelClass order: 0! !

!ComposableModelDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/28/2012 14:01'!
addInstVarNamed: aString kindOfComposablaeModel: aComposableModelClass order: order

	self addInstVarNamed: aString kindOf: aComposableModelClass.
	self addCodeToInitialize: aString, ' := self instantiate: ', aComposableModelClass name order: order! !

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 07:55'!
addIntoMethodDescriptions
	^ addIntoMethodDescriptions! !

!ComposableModelDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/27/2012 06:58'!
addMethodDescriptions
	^ addMethodDescriptions! !

!ComposableModelDescription methodsFor: 'protocol-basic' stamp: 'BenjaminVanRyseghem 2/27/2012 07:48'!
addMethodWithSource: source category: category

	addMethodDescriptions add: (AddMethodDescription
										category: category
										source: source)! !

!ComposableModelDescription methodsFor: 'processing' stamp: 'BenjaminVanRyseghem 2/28/2012 20:24'!
generateSpec
	| spec |
	spec := OrderedCollection new 
		addAll: (addClassDescription generateSpec);
		addAll: (addInstVarDescriptions gather: #generateSpec);
		addAll: (addMethodDescriptions gather: #generateSpec);
		addAll: ((addIntoMethodDescriptions sort: [:a :b | a order < b order ]) gather: #generateSpec);
		yourself.
		
	^ spec addAll: {#class. #compileWithoutReturn:classified:. 'generatingSpec
	
	^ ', (spec copy addFirst: #model;yourself) asArray storeString. 'generating'};yourself! !

!ComposableModelDescription methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/27/2012 07:56'!
initialize
	"Initialization code for ComposableModelDescription"

	super initialize.

	addInstVarDescriptions := OrderedCollection new.
	addIntoMethodDescriptions := OrderedCollection new.
	addMethodDescriptions := OrderedCollection new.! !

Object subclass: #SpecBuilder
	instanceVariableNames: 'toto titi'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Builder'!

!SpecBuilder class methodsFor: 'experimentation' stamp: 'BenjaminVanRyseghem 2/28/2012 14:04'!
example
	| cmd |
	cmd := ComposableModelDescription new.
	cmd addClassNamed: #SpecTest categorized: 'Spec-Builder'.
	cmd addInstVarNamed: 'toto' kindOfComposablaeModel: TextModel.
	cmd addInstVarNamed: 'titi' kindOf: NewValueHolder.
	cmd addMethodWithSource: 'test1 ^1' category: 'test'.
	cmd addMethodWithSource: 'test2 ^2' category: 'test'.
	cmd addCodeToInitialize: 'self test2.' order: 2.
	cmd addCodeToInitialize: 'self test1' order: 1.

	SpecInterpreter interpretASpec: cmd generate model: ComposableModel.


! !

!SpecBuilder class methodsFor: 'experimentation' stamp: 'BenjaminVanRyseghem 2/27/2012 06:36'!
exp1

	^{#model.
		#addInstVarNamed:. 'toto'.
		#compile:classified:. 	'method	^ true'. 'test'}! !

!SpecBuilder methodsFor: 'test' stamp: 'BenjaminVanRyseghem 2/27/2012 06:57'!
iAmATest

	^ 'I am a test'! !

!SpecBuilder methodsFor: 'test' stamp: 'BenjaminVanRyseghem 2/27/2012 06:36'!
method	^ true! !

!ClassDescription methodsFor: '*Spec-Builder' stamp: 'BenjaminVanRyseghem 2/27/2012 07:50'!
compileWithoutReturn: code classified: heading

	self compile: code classified: heading! !
